Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.option.xom
Class XOMWriter

    java.lang.Object
      net.sf.saxon.event.Builder
          net.sf.saxon.option.xom.XOMWriter

All Implemented Interfaces:
  Result, Receiver

    public class XOMWriter

extends Builder

XOMWriter is a Receiver that constructs a XOM document from the stream of events

Field Summary

Fields inherited from class net.sf.saxon.event.Builder
`baseURI, config, currentRoot, JDOM_TREE, JDOM2_TREE, lineNumbering, LINKED_TREE, namePool, open, pipe, STANDARD_TREE, started, systemId, timing, TINY_TREE, TINY_TREE_CONDENSED, UNSPECIFIED_TREE_MODEL`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`XOMWriter(PipelineConfiguration pipe)` Create a XOMWriter using the default node factory
`XOMWriter(PipelineConfiguration pipe, NodeFactory factory)` Create a XOMWriter

Method Summary
`void` | `attribute(NodeName nameCode, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Character data.
`void` | `close()` End of the document.
`void` | `comment(CharSequence chars, int locationId, int properties)` Handle a comment.
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` End of an element.
`NodeInfo` | `getCurrentRoot()` Get the current root node.
`Document` | `getDocument()` Get the constructed document node
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`void` | `open()` Start of the document.
`void` | `processingInstruction(String target, CharSequence data, int locationId, int properties)` Handle a processing instruction.
`void` | `setUnparsedEntity(String name, String systemID, String publicID)` Notify an unparsed entity URI.
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Start of a document node.
`void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` Start of an element.
`boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

Methods inherited from class net.sf.saxon.event.Builder
`getBaseURI, getBuilderMonitor, getConfiguration, getPipelineConfiguration, getSystemId, isTiming, reset, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XOMWriter

    public XOMWriter(PipelineConfiguration pipe)

  Create a XOMWriter using the default node factory

  Parameters:
    `pipe` - the pipeline configuration

### XOMWriter

    public XOMWriter(PipelineConfiguration pipe,
                     NodeFactory factory)

  Create a XOMWriter

  Parameters:
    `pipe` - the pipeline configuration
    `factory` - the XOM NodeFactory to be used

Method Detail

### setUnparsedEntity

    public void setUnparsedEntity(String name,
                                  String systemID,
                                  String publicID)
                           throws XPathException

  Notify an unparsed entity URI.

  Parameters:
    `name` - The name of the unparsed entity
    `systemID` - The system identifier of the unparsed entity
    `publicID` - The public identifier of the unparsed entity
  Throws:
    `XPathException` - if an error occurs

### open

    public void open()

  Start of the document.

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `Builder`

### close

    public void close()

  End of the document.

  Specified by:
    `close` in interface `Receiver`
  Overrides:
    `close` in class `Builder`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Throws:
    `XPathException` - if an error occurs

### startElement

    public void startElement(NodeName nameCode,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Start of an element.

  Parameters:
    `nameCode` - the name of the element.
    `typeCode` - the type annotation of the element.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceBinding` - contains the namespace prefix and namespace URI
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
  Throws:
    `XPathException` - if an error occurs

### attribute

    public void attribute(NodeName nameCode,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException` - if an error occurs

### endElement

    public void endElement()
                    throws XPathException

  End of an element.

  Throws:
    `XPathException` - if an error occurs

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - if an error occurs

### processingInstruction

    public void processingInstruction(String target,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Handle a processing instruction.

  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `XPathException` - if an error occurs

### comment

    public void comment(CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Handle a comment.

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException` - if an error occurs

### usesTypeAnnotations

    public boolean usesTypeAnnotations()

  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Specified by:
    `usesTypeAnnotations` in interface `Receiver`
  Overrides:
    `usesTypeAnnotations` in class `Builder`
  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

### getDocument

    public Document getDocument()

  Get the constructed document node

  Returns:
    the document node of the constructed XOM tree

### getCurrentRoot

    public NodeInfo getCurrentRoot()

  Get the current root node.

  Overrides:
    `getCurrentRoot` in class `Builder`
  Returns:
    a Saxon wrapper around the constructed XOM document node

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.